## crafty 20.14

=== Makefile ===
# To build crafty:
#
#	  You want to set up for maximum optimization, but typically you will
#	  need to experiment to see which options provide the fastest code.
#	  This is optimized for gcc, which is a fairly current compiler.
#   
#   The currently available targets:
#
#     aix          {IBM machines running AIX}
#     alpha        {DEC Alpha running OSF/1-Digital Unix}
#     darwin       {PPC on Mac OSX}
#     freebsd      {80X86 architecture running FreeBSD (Unix)}
#     hpux         {HP workstation running HP_UX operating system (Unix)}
#     linux        {80X86 architecture running LINUX (Unix) (gcc)}
#     linux-alpha  {Digital Alpha processor running LINUX (Unix)}
#     linux-amd64  {AMD X86-64 (opteron) running LINUX (Unix)}
#     linux-icc    {80X86 architecture running LINUX (Unix) (Intel compiler)}
#     netbsd       {80X86 architecture running netbsd(Unix)}
#     netbsd-sparc {sparc architecture running netbsd(Unix)}
#     next         {NextStep}
#     sgi          {SGI Workstation running Irix (SYSV/R4) Unix}
#     solaris      {Sun SparcStation running Solaris (SYSV/R4) Unix}
#     solaris-gcc  {Sun SparcStation running Solaris but using gcc}
#   
#   The next options are optimizations inside Crafty that you will have
#   test to see if they help.  on some machines, these will slow things
#   by up to 10%, while on other machines these options will result in
#   improving search speed up to 20%.  NOTE:  if you are running Linux
#   system, the default configurations below will use the hand-written
#   assembly modules.  Typical performance improvement is 5%, but this
#   only applies to X86 machines running Linux.
#   
#                default
#   -DBOOKDIR      N  path to the directory containing the book binary files.
#                     The default for all such path values is "." if you don't
#                     specify a path with this macro definition.
#   -DCPUS=n       N  defines the maximum number of CPUS Crafty will be able
#                     to use in a SMP system.  Note that this is the max you
#                     will be able to use.  You need to use the smpmt=n command
#                     to make crafty use more than the default 1 process.
#   -DDGT          N  This is a unix-only option to support the DGT board.
#   -DEPD          Y  if you want full EPD support built in.
#   -DHASHSTATS    N  This option compiles in some of the statistics 
#                     gathering to provide hashing statistics.
#   -DINLINE32     N  Compiles with the Intel assembly code for FirstOne(),
#                     LastOne() and PopCnt().  This is for gcc-style inlining
#                     and now works with the Intel C/C++ compiler as well.
#   -DINLINE64     N  Compiles with the Intel assembly code for FirstOne(),
#                     LastOne() and PopCnt() for the AMD opteron, only tested
#                     with the 64-bit opteron GCC compiler / Intel ICC compiler.
#   -DLIMITEXT     N  limit extensions as search gets deeper
#   -DLOGDIR       N  path to the directory where Crafty puts the log.nnn and
#                     game.nnn files.
#   -DNOEGTB       N  eliminates the egtb code for compilers that can't deal
#                     with the large egtb.cpp code/templates.
#   -DNOFUTILITY   N  disables classic futility pruning
#   -DNUMA         N  says this system is NUMA, which is mainly used for Linux
#                     systems, and references libnuma, needed for the NUMA calls
#                     (crafty doesn't use many of these, it does the memory
#                     setup stuff itself)
#   -DPOWERPC      N  enables PPC spinlock inline function for SMP boxes only
#   -DRCDIR        N  path to the directory where we look for the .craftyrc or
#                     crafty.rc (windows) file.
#   -DSMP          N  enables SMP support (not clustering).  If you choose
#                     this option, you need to look closely at the following
#                     two options as well.
#   -DTBDIR        N  path to the directory where the endgame tablebase files
#                     are found.  default = "./TB"
#   -DTRACE        N  This enables the "trace" command so that the search tree
#                     can be dumped while running.

default:
	$(MAKE) -j linux-icc
help:
	@echo "You must specify the system which you want to compile for:"
	@echo ""
	@echo "make aix              IBM AIX"
	@echo "make alpha            DEC Alpha with OSF/1-Digital UNIX"
	@echo "make alpha-host       Alpha DECstation optimized for host"
	@echo "make alpha-host-nocix Alpha DECstation optimezed for host, no CIX insn"
	@echo "make darwin           Darwin on OSX"
	@echo "make hpux             HP/UX 9/10, /7xx"
	@echo "make linux            Linux optimized for i386, ELF format"
	@echo "make linux-alpha      Linux optimized for alpha"
	@echo "make linux-AMD64      Linux optimized for AMD opteron"
	@echo "make freebsd          FreeBSD"
	@echo "make netbsd           NetBSD"
	@echo "make netbsd-sparc     NetBSD optimized for sparc"
	@echo "make next             NeXTSTEP"
	@echo "make sgi              SGI running IRIX"
	@echo "make solaris          Solaris 2.x"
	@echo "make solaris-gcc      Solaris 2.x using GNU cc"
	@echo ""
	@echo "make generic          Try this one if your system isn't listed above;"
	@echo "                      it assumes you have installed GNU cc"
	@echo ""

aix:
	$(MAKE) target=AIX \
		CC=cc CXX=$(CC) \
		CFLAGS='$(CFLAGS) -O2' \
		CXFLAGS=$(CFLAGS) \
		opt='$(opt)' \
		crafty-make

alpha:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -newc' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lexc' \
		opt='$(opt)' \
		crafty-make

alpha-host:
	$(MAKE) target=ALPHA \
		CC=cc CXX=cxx \
		CFLAGS='$(CFLAGS) -std -fast -O4 -newc -arch host' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='-lexc' \
		opt='$(opt)' \
		crafty-make

darwin:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -O3' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		LIBS='-lstdc++' \
		opt='$(opt)' \
		crafty-make

darwinG5:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O3 -mcpu=G5 \
			-mtune=G5 -fomit-frame-pointer -fast' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lstdc++' \
		opt='$(opt) -DSMP -DCPUS=4 -DPOWERPC' \
		crafty-make
	
freebsd:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3 -Wall' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DINLINE32' \
		crafty-make

freebsd-pgcc:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -pipe -D_REENTRANT -mpentium -O -Wall' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DINLINE32' \
		crafty-make

hpux:
	$(MAKE) target=HP \
		CC=cc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) +ESlit -Ae +w1' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) +O3 +Onolimit $(CFLAGS)' \
		crafty-make

linux-amd64-profile:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
                CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT \
                        -fprofile-arcs -fomit-frame-pointer -O3 -march=k8' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lnuma -fprofile-arcs -lstdc++' \
		opt='$(opt) -DINLINE64 -DSMP -DCPUS=8 -DNUMA -DLIBNUMA' \
		crafty-make

linux-amd64:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
                CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT \
                -fbranch-probabilities -fomit-frame-pointer -O3 -march=k8' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lnuma -lstdc++' \
		opt='$(opt) -DINLINE64 -DSMP -DCPUS=8 -DNUMA -DLIBNUMA' \
		crafty-make

linux:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
			-fbranch-probabilities -fforce-mem -fomit-frame-pointer\
			-fno-gcse -mpreferred-stack-boundary=2' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lstdc++' \
		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
		crafty-make

linux-profile:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
			-fprofile-arcs -fforce-mem -fomit-frame-pointer \
			-fno-gcse -mpreferred-stack-boundary=2' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -fprofile-arcs -lstdc++ ' \
		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
		crafty-make

linux-icc:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
			-xN -prof_use -prof_dir ./profdir \
			-Ob2 -fno-alias' \
		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
			-w -xN -prof_use -prof_dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lstdc++' \
		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
		crafty-make

linux-icc-profile:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
			-xN -prof_genx -prof_dir ./profdir \
			-Ob2 -fno-alias' \
		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
			-w -xN -prof_genx -prof_dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lstdc++ ' \
		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
		crafty-make

linux-alpha:
	$(MAKE) target=ALPHA \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -O4 -ffast-math -funroll-loops' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
		LIBS='' \
		opt='$(opt) -DNOBUILTINS' \
		crafty-make

netbsd:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DINLINE32' \
		crafty-make

netbsd-i386:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall -m486 \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DINLINE32' \
		crafty-make

netbsd-sparc:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
			-fomit-frame-pointer -funroll-all-loops \
			-finline-functions -ffast-math' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt)' \
		crafty-make

next:
	$(MAKE) target=NEXT \
		CC=/bin/cc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -O2' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) $(CFLAGS)'
		opt='$(opt)' \
		crafty-make

sgi:
	$(MAKE) target=SGI \
		AS=/bin/as CC=cc CXX='$(CC)' \
		AFLAGS='-P' \
		CFLAGS='$(CFLAGS) -32 -mips2 -cckr' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt)' \
		crafty-make

solaris:
	$(MAKE) target=SUN \
		CC=cc CXX='$(CC)' \
		CFLAGS='$(CFLAGS) -fast -xO5 -xunroll=20' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt)' \
		crafty-make

solaris-gcc:
	$(MAKE) target=SUN \
		CC=gcc CXX=g++ \
		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O2 \
			-fforce-mem -fomit-frame-pointer' \
		CXFLAGS=$(CFLAGS) \
		LDFLAGS='$(LDFLAGS) -lstdc++' \
		opt='$(opt)' \
		crafty-make

profile:
	@rm -rf profdir
	@rm -rf position.bin
	@mkdir profdir
	@touch *.c *.cpp *.h
	$(MAKE) linux-icc-profile
	@echo "#!/bin/csh" > runprof
	@echo "./crafty <<EOF" >>runprof
	@echo "st=10" >>runprof
	@echo "ponder=off" >>runprof
	@echo "display nomoves" >>runprof
	@echo "setboard rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq" >>runprof
	@echo "move" >>runprof
	@echo "book off" >>runprof
	@echo "setboard rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq" >>runprof
	@echo "move" >>runprof
	@echo "setboard 1k1r4/pp1b1R2/3q2pp/4p3/2B5/4Q3/PPP2B2/2K5 b" >>runprof
	@echo "move" >>runprof
	@echo "setboard 3r1k2/4npp1/1ppr3p/p6P/P2PPPP1/1NR5/5K2/2R5 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 2q1rr1k/3bbnnp/p2p1pp1/2pPp3/PpP1P1P1/1P2BNNP/2BQ1PRK/7R b" >>runprof
	@echo "move" >>runprof
	@echo "setboard rnbqkb1r/p3pppp/1p6/2ppP3/3N4/2P5/PPP1QPPP/R1B1KB1R w KQkq" >>runprof
	@echo "move" >>runprof
	@echo "setboard r1b2rk1/2q1b1pp/p2ppn2/1p6/3QP3/1BN1B3/PPP3PP/R4RK1 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 2r3k1/pppR1pp1/4p3/4P1P1/5P2/1P4K1/P1P5/8 w" >>runprof
	@echo "move" >>runprof

## crafty 23.1

=== Makefile ===
--- 
+++ 
@@ -38,10 +38,7 @@
 #                     to use in a SMP system.  Note that this is the max you
 #                     will be able to use.  You need to use the smpmt=n command
 #                     to make crafty use more than the default 1 process.
-#   -DDGT          N  This is a unix-only option to support the DGT board.
 #   -DEPD          Y  if you want full EPD support built in.
-#   -DHASHSTATS    N  This option compiles in some of the statistics 
-#                     gathering to provide hashing statistics.
 #   -DINLINE32     N  Compiles with the Intel assembly code for FirstOne(),
 #                     LastOne() and PopCnt().  This is for gcc-style inlining
 #                     and now works with the Intel C/C++ compiler as well.
@@ -61,16 +58,13 @@
 #   -DPOWERPC      N  enables PPC spinlock inline function for SMP boxes only
 #   -DRCDIR        N  path to the directory where we look for the .craftyrc or
 #                     crafty.rc (windows) file.
-#   -DSMP          N  enables SMP support (not clustering).  If you choose
-#                     this option, you need to look closely at the following
-#                     two options as well.
 #   -DTBDIR        N  path to the directory where the endgame tablebase files
 #                     are found.  default = "./TB"
 #   -DTRACE        N  This enables the "trace" command so that the search tree
 #                     can be dumped while running.
 
 default:
-	$(MAKE) -j linux-icc
+	$(MAKE) linux
 help:
 	@echo "You must specify the system which you want to compile for:"
 	@echo ""
@@ -103,44 +97,24 @@
 		opt='$(opt)' \
 		crafty-make
 
-alpha:
-	$(MAKE) target=ALPHA \
-		CC=cc CXX=cxx \
-		CFLAGS='$(CFLAGS) -std -fast -O4 -newc' \
-		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
-		LIBS='-lexc' \
-		opt='$(opt)' \
-		crafty-make
-
-alpha-host:
-	$(MAKE) target=ALPHA \
-		CC=cc CXX=cxx \
-		CFLAGS='$(CFLAGS) -std -fast -O4 -newc -arch host' \
-		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
-		LIBS='-lexc' \
-		opt='$(opt)' \
-		crafty-make
-
 darwin:
 	$(MAKE) target=FreeBSD \
 		CC=gcc CXX=g++ \
 		CFLAGS='$(CFLAGS) -Wall -pipe -O3' \
 		CXFLAGS=$(CFLAGS) \
 		LDFLAGS=$(LDFLAGS) \
-		LIBS='-lstdc++' \
+		LIBS='-lpthread -lstdc++' \
 		opt='$(opt)' \
 		crafty-make
 
 darwinG5:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O3 -mcpu=G5 \
+		CFLAGS='$(CFLAGS) -Wall -pipe -O3 -mcpu=G5 \
 			-mtune=G5 -fomit-frame-pointer -fast' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lstdc++' \
-		opt='$(opt) -DSMP -DCPUS=4 -DPOWERPC' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
+		opt='$(opt) -DCPUS=4 -DPOWERPC' \
 		crafty-make
 	
 freebsd:
@@ -148,16 +122,16 @@
 		CC=gcc CXX='$(CC)' \
 		CFLAGS='$(CFLAGS) -fomit-frame-pointer -m486 -O3 -Wall' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt) -DINLINE32' \
 		crafty-make
 
 freebsd-pgcc:
 	$(MAKE) target=FreeBSD \
 		CC=gcc CXX='$(CC)' \
-		CFLAGS='$(CFLAGS) -pipe -D_REENTRANT -mpentium -O -Wall' \
-		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		CFLAGS='$(CFLAGS) -pipe -mpentium -O -Wall' \
+		CXFLAGS=$(CFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt) -DINLINE32' \
 		crafty-make
 
@@ -172,109 +146,98 @@
 linux-amd64-profile:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-                CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT \
+                CFLAGS='$(CFLAGS) -Wall -pipe \
                         -fprofile-arcs -fomit-frame-pointer -O3 -march=k8' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lnuma -fprofile-arcs -lstdc++' \
-		opt='$(opt) -DINLINE64 -DSMP -DCPUS=8 -DNUMA -DLIBNUMA' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lnuma -fprofile-arcs -lstdc++' \
+		opt='$(opt) -DINLINE64 -DCPUS=8 -DNUMA -DLIBNUMA' \
 		crafty-make
 
 linux-amd64:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-                CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT \
+                CFLAGS='$(CFLAGS) -Wall -pipe \
                 -fbranch-probabilities -fomit-frame-pointer -O3 -march=k8' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lnuma -lstdc++' \
-		opt='$(opt) -DINLINE64 -DSMP -DCPUS=8 -DNUMA -DLIBNUMA' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lnuma -lstdc++' \
+		opt='$(opt) -DINLINE64 -DCPUS=8 -DNUMA -DLIBNUMA' \
 		crafty-make
 
 linux:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
-			-fbranch-probabilities -fforce-mem -fomit-frame-pointer\
+		CFLAGS='$(CFLAGS) -Wall -pipe -march=i686 -O3 \
 			-fno-gcse -mpreferred-stack-boundary=2' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lstdc++' \
-		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
+		opt='$(opt) -DTRACE -DINLINE32 -DCPUS=2' \
 		crafty-make
 
 linux-profile:
 	$(MAKE) target=LINUX \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -march=i686 -O3 \
+		CFLAGS='$(CFLAGS) -Wall -pipe -march=i686 -O3 \
 			-fprofile-arcs -fforce-mem -fomit-frame-pointer \
 			-fno-gcse -mpreferred-stack-boundary=2' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -fprofile-arcs -lstdc++ ' \
-		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++ ' \
+		opt='$(opt) -DINLINE32 -DCPUS=2' \
 		crafty-make
 
 linux-icc:
 	$(MAKE) target=LINUX \
 		CC=icc CXX=icc \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
+		CFLAGS='$(CFLAGS) -O2 \
 			-xN -prof_use -prof_dir ./profdir \
 			-Ob2 -fno-alias' \
-		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
+		CXFLAGS='$(CFLAGS) -O2 \
 			-w -xN -prof_use -prof_dir ./profdir' \
-		LDFLAGS='$(LDFLAGS) -lstdc++' \
-		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
+		opt='$(opt) -DTEST -DINLINE32 -DCPUS=4' \
 		crafty-make
 
 linux-icc-profile:
 	$(MAKE) target=LINUX \
 		CC=icc CXX=icc \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
+		CFLAGS='$(CFLAGS) -O2 \
 			-xN -prof_genx -prof_dir ./profdir \
 			-Ob2 -fno-alias' \
-		CXFLAGS='$(CFLAGS) -D_REENTRANT -O2 \
+		CXFLAGS='$(CFLAGS) -O2 \
 			-w -xN -prof_genx -prof_dir ./profdir' \
-		LDFLAGS='$(LDFLAGS) -lstdc++ ' \
-		opt='$(opt) -DINLINE32 -DSMP -DCPUS=2' \
-		crafty-make
-
-linux-alpha:
-	$(MAKE) target=ALPHA \
-		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -O4 -ffast-math -funroll-loops' \
-		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) $(CFLAGS)' \
-		LIBS='' \
-		opt='$(opt) -DNOBUILTINS' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++ ' \
+		opt='$(opt) -DTEST -DINLINE32 -DCPUS=2' \
 		crafty-make
 
 netbsd:
 	$(MAKE) target=NetBSD \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
+		CFLAGS='$(CFLAGS) -O3 -Wall \
 			-fomit-frame-pointer -funroll-all-loops \
 			-finline-functions -ffast-math' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt) -DINLINE32' \
 		crafty-make
 
 netbsd-i386:
 	$(MAKE) target=NetBSD \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall -m486 \
+		CFLAGS='$(CFLAGS) -O3 -Wall -m486 \
 			-fomit-frame-pointer -funroll-all-loops \
 			-finline-functions -ffast-math' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt) -DINLINE32' \
 		crafty-make
 
 netbsd-sparc:
 	$(MAKE) target=NetBSD \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -D_REENTRANT -O3 -Wall \
+		CFLAGS='$(CFLAGS) -O3 -Wall \
 			-fomit-frame-pointer -funroll-all-loops \
 			-finline-functions -ffast-math' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt)' \
 		crafty-make
 
@@ -283,7 +246,7 @@
 		CC=/bin/cc CXX='$(CC)' \
 		CFLAGS='$(CFLAGS) -O2' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) $(CFLAGS)'
+		LDFLAGS='$(LDFLAGS) $(CFLAGS) -lpthread'
 		opt='$(opt)' \
 		crafty-make
 
@@ -293,7 +256,7 @@
 		AFLAGS='-P' \
 		CFLAGS='$(CFLAGS) -32 -mips2 -cckr' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS=$(LDFLAGS) \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt)' \
 		crafty-make
 
@@ -302,17 +265,17 @@
 		CC=cc CXX='$(CC)' \
 		CFLAGS='$(CFLAGS) -fast -xO5 -xunroll=20' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS)' \
+		LDFLAGS='$(LDFLAGS) -lpthread' \
 		opt='$(opt)' \
 		crafty-make
 
 solaris-gcc:
 	$(MAKE) target=SUN \
 		CC=gcc CXX=g++ \
-		CFLAGS='$(CFLAGS) -Wall -pipe -D_REENTRANT -O2 \
+		CFLAGS='$(CFLAGS) -Wall -pipe -O2 \
 			-fforce-mem -fomit-frame-pointer' \
 		CXFLAGS=$(CFLAGS) \
-		LDFLAGS='$(LDFLAGS) -lstdc++' \
+		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
 		opt='$(opt)' \
 		crafty-make
 
@@ -321,7 +284,7 @@
 	@rm -rf position.bin
 	@mkdir profdir
 	@touch *.c *.cpp *.h
-	$(MAKE) linux-icc-profile
+	$(MAKE) linux-profile
 	@echo "#!/bin/csh" > runprof
 	@echo "./crafty <<EOF" >>runprof
 	@echo "st=10" >>runprof
@@ -344,3 +307,25 @@
 	@echo "move" >>runprof
 	@echo "setboard 2r3k1/pppR1pp1/4p3/4P1P1/5P2/1P4K1/P1P5/8 w" >>runprof
 	@echo "move" >>runprof
+	@echo "setboard 1nk1r1r1/pp2n1pp/4p3/q2pPp1N/b1pP1P2/B1P2R2/2P1B1PP/R2Q2K1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 4b3/p3kp2/6p1/3pP2p/2pP1P2/4K1P1/P3N2P/8 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 2kr1bnr/pbpq4/2n1pp2/3p3p/3P1P1B/2N2N1Q/PPP3PP/2KR1B1R w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 3rr1k1/pp3pp1/1qn2np1/8/3p4/PP1R1P2/2P1NQPP/R1B3K1 b" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 2r1nrk1/p2q1ppp/bp1p4/n1pPp3/P1P1P3/2PBB1N1/4QPPP/R4RK1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard r3r1k1/ppqb1ppp/8/4p1NQ/8/2P5/PP3PPP/R3R1K1 b" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard r2q1rk1/4bppp/p2p4/2pP4/3pP3/3Q4/PP1B1PPP/R3R1K1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard rnb2r1k/pp2p2p/2pp2p1/q2P1p2/8/1Pb2NP1/PB2PPBP/R2Q1RK1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard 2r3k1/1p2q1pp/2b1pr2/p1pp4/6Q1/1P1PP1R1/P1PN2PP/5RK1 w" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard r1bqkb1r/4npp1/p1p4p/1p1pP1B1/8/1B6/PPPN1PPP/R2Q1RK1 w kq" >>runprof
+	@echo "move" >>runprof
+	@echo "setboard r2q1rk1/1ppnbppp/p2p1nb1/3Pp3/2P1P1P1/2N2N1P/PPB1QP2/R1B2RK1 b" >>runprof
+	@echo "move" >>runprof

## crafty 23.4

=== Makefile ===
# To build crafty:
#
#  You want to set up for maximum optimization, but typically you will
#  need to experiment to see which options provide the fastest code.
#   
#   -DBOOKDIR      N  path to the directory containing the book binary files.
#                     The default for all such path values is "." if you don't
#                     specify a path with this macro definition.
#   -DCPUS=n       N  defines the maximum number of CPUS Crafty will be able
#                     to use in a SMP system.  Note that this is the max you
#                     will be able to use.  You need to use the smpmt=n command
#                     to make crafty use more than the default 1 process.
#   -DEPD          Y  if you want full EPD support built in.
#   -DINLINE32     N  Compiles with the Intel assembly code for FirstOne(),
#                     LastOne() and PopCnt().  This is for gcc-style inlining
#                     and now works with the Intel C/C++ compiler as well.
#   -DINLINE64     N  Compiles with the Intel assembly code for FirstOne(),
#                     LastOne() and PopCnt() for the AMD opteron, only tested
#                     with the 64-bit opteron GCC compiler / Intel ICC compiler.
#   -DLIMITEXT     N  limit extensions as search gets deeper
#   -DLOGDIR       N  path to the directory where Crafty puts the log.nnn and
#                     game.nnn files.
#   -DNOEGTB       N  eliminates the egtb code for compilers that can't deal
#                     with the large egtb.cpp code/templates.
#   -DNOFUTILITY   N  disables classic futility pruning
#   -DNUMA         N  says this system is NUMA, which is mainly used for Linux
#                     systems, and references libnuma, needed for the NUMA calls
#                     (crafty doesn't use many of these, it does the memory
#                     setup stuff itself)
#   -DPOPCNT       N  Compiles with the Intel assembly code for hardware popcnt
#                     instruction, only applies to Nehalem and beyond (I think
#                     this is SSE 4.2 or something similar).
#   -DPOWERPC      N  enables PPC spinlock inline function for SMP boxes only
#   -DRCDIR        N  path to the directory where we look for the .craftyrc or
#                     crafty.rc (windows) file.
#   -DTBDIR        N  path to the directory where the endgame tablebase files
#                     are found.  default = "./TB"
#   -DTRACE        N  This enables the "trace" command so that the search tree
#                     can be dumped while running.

default:
	$(MAKE) linux-64
help:
	@echo "You must specify the system which you want to compile for:"
	@echo ""
	@echo "make aix              IBM AIX"
	@echo "make darwin           Darwin on OSX"
	@echo "make hpux             HP/UX 9/10, /7xx"
	@echo "make linux            Linux optimized for i386, ELF format"
	@echo "make linux-AMD64      Linux optimized for AMD opteron"
	@echo "make freebsd          FreeBSD"
	@echo "make netbsd           NetBSD"
	@echo "make netbsd-sparc     NetBSD optimized for sparc"
	@echo "make solaris          Solaris 2.x"
	@echo "make solaris-gcc      Solaris 2.x using GNU cc"
	@echo ""

aix:
	$(MAKE) target=AIX \
		CC=cc CXX=$(CC) \
		CFLAGS='-O2' \
		CXFLAGS='' \
		opt='$(opt)' \
		crafty-make

darwin:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX=g++ \
		CFLAGS='-Wall -pipe -O3' \
		CXFLAGS='-Wall -pipe -O3' \
		LDFLAGS=$(LDFLAGS) \
		LIBS='-lstdc++' \
		opt='$(opt)' \
		crafty-make

darwinG5:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='-Wall -pipe -O3 -mcpu=G5 -mtune=G5 -fomit-frame-pointer -fast' \
		CXFLAGS='-Wall -pipe -O3 -mcpu=G5 -mtune=G5 -fomit-frame-pointer -fast' \
		LDFLAGS='$(LDFLAGS) -lstdc++' \
		opt='$(opt) -DCPUS=4 -DPOWERPC' \
		crafty-make
	
freebsd:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$(CC)' \
		CFLAGS='-fomit-frame-pointer -m486 -O3 -Wall' \
		CXFLAGS='-fomit-frame-pointer -m486 -O3 -Wall' \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DINLINE32' \
		crafty-make

freebsd-pgcc:
	$(MAKE) target=FreeBSD \
		CC=gcc CXX='$(CC)' \
		CFLAGS='-pipe -mpentium -O -Wall' \
		CXFLAGS='' \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DINLINE32' \
		crafty-make

hpux:
	$(MAKE) target=HP \
		CC=cc CXX='$(CC)' \
		CFLAGS='+ESlit -Ae +w1' \
		CXFLAGS='' \
		LDFLAGS='$(LDFLAGS) +O3 +Onolimit' \
		crafty-make

linux-amd64-profile:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
                CFLAGS='-Wall -pipe -fprofile-arcs -fomit-frame-pointer -O3 -march=k8' \
		CXFLAGS='' \
		LDFLAGS='$(LDFLAGS) -lpthread -lnuma -fprofile-arcs -lstdc++' \
		opt='$(opt) -DINLINE64 -DCPUS=8 -DNUMA -DLIBNUMA' \
		crafty-make

linux-amd64:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
                CFLAGS='-Wall -pipe -fbranch-probabilities -fomit-frame-pointer -O3 -march=k8' \
		CXFLAGS='' \
		LDFLAGS='$(LDFLAGS) -lpthread -lnuma -lstdc++' \
		opt='$(opt) -DINLINE64 -DCPUS=8 -DNUMA -DLIBNUMA' \
		crafty-make

linux:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='-pg -Wwrite-strings -Wcast-qual -Wshadow \
		-Wconversion -W -Wall -ansi -pedantic -pipe' \
		CXFLAGS='' \
		LDFLAGS='$(LDFLAGS) -pg -lstdc++ -lpthread' \
		opt='$(opt) -DTRACE -DINLINE64 -DCPUS=2' \
		crafty-make

linux-profile:
	$(MAKE) target=LINUX \
		CC=gcc CXX=g++ \
		CFLAGS='-Wall -pipe -O3 -fprofile-arcs' \
		CXFLAGS='' \
		LDFLAGS='$(LDFLAGS) -fprofile-arcs -lstdc++ ' \
		opt='$(opt) -DINLINE32 -DCPUS=2' \
		crafty-make

debug:
	$(MAKE) target=LINUX \
		CC=gcc CXX=gcc \
		CFLAGS='-O2 -w -g' \
		CXFLAGS='-O2 -w -g' \
		LDFLAGS='$(LDFLAGS) -g -lpthread -lstdc++' \
		opt='$(opt) -DINLINE64 -DCPUS=2' \
		crafty-make

linux-64:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='-w -xP -O2 -fno-alias -prof-use -prof_dir ./profdir' \
		CXFLAGS='-w -xP -O2 -prof-use -prof-dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++' \
		opt='$(opt) -DINLINE64 -DCPUS=2' \
		crafty-make

linux-64-profile:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='-w -xP -O2 -fno-alias -prof-gen=srcpos -prof-dir ./profdir' \
		CXFLAGS='-w -xP -O2 -ip -prof-gen=srcpos -prof-dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lpthread -lstdc++ ' \
		opt='$(opt) -DINLINE64 -DCPUS=2' \
		crafty-make

linux-icc:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='-w -O2 -prof_use -prof_dir ./profdir -fno-alias' \
		CXFLAGS='-w -O2 -prof_use -prof_dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lstdc++' \
		opt='$(opt) -DINLINE32 -DCPUS=1' \
		crafty-make

linux-icc-profile:
	$(MAKE) target=LINUX \
		CC=icc CXX=icc \
		CFLAGS='-w -O2 -prof_genx -prof_dir ./profdir -fno-alias' \
		CXFLAGS='-w -O2 -prof_genx -prof_dir ./profdir' \
		LDFLAGS='$(LDFLAGS) -lstdc++ ' \
		opt='$(opt) -DINLINE32 -DCPUS=2' \
		crafty-make

netbsd:
	$(MAKE) target=NetBSD \
		CC=gcc CXX=g++ \
		CFLAGS='-O3 -Wall -fomit-frame-pointer' \
		CXFLAGS='-O3 -Wall -fomit-frame-pointer' \
		LDFLAGS=$(LDFLAGS) \
		opt='$(opt) -DINLINE32' \
		crafty-make

solaris:
	$(MAKE) target=SUN \
		CC=cc CXX='$(CC)' \
		CFLAGS='-fast -xO5 -xunroll=20' \
		CXFLAGS='-fast -xO5 -xunroll=20' \
		LDFLAGS='$(LDFLAGS)' \
		opt='$(opt)' \
		crafty-make

solaris-gcc:
	$(MAKE) target=SUN \
		CC=gcc CXX=g++ \
		CFLAGS='-Wall -pipe -O2 -fforce-mem -fomit-frame-pointer' \
		CXFLAGS='-Wall -pipe -O2 -fforce-mem -fomit-frame-pointer' \
		LDFLAGS='$(LDFLAGS) -lstdc++' \
		opt='$(opt)' \
		crafty-make

profile:
	@rm -rf profdir
	@rm -rf position.bin
	@mkdir profdir
	@touch *.c *.cpp *.h
	$(MAKE) linux-64-profile
	@echo "#!/bin/csh" > runprof
	@echo "./crafty <<EOF" >>runprof
	@echo "st=10" >>runprof
	@echo "ponder=off" >>runprof
	@echo "display nomoves" >>runprof
	@echo "setboard rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq" >>runprof
	@echo "move" >>runprof
	@echo "book off" >>runprof
	@echo "setboard rnbqkbnr/pppppppp/8/8/8/8/PPPPPPPP/RNBQKBNR w KQkq" >>runprof
	@echo "move" >>runprof
	@echo "setboard 1k1r4/pp1b1R2/3q2pp/4p3/2B5/4Q3/PPP2B2/2K5 b" >>runprof
	@echo "move" >>runprof
	@echo "setboard 3r1k2/4npp1/1ppr3p/p6P/P2PPPP1/1NR5/5K2/2R5 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 2q1rr1k/3bbnnp/p2p1pp1/2pPp3/PpP1P1P1/1P2BNNP/2BQ1PRK/7R b" >>runprof
	@echo "move" >>runprof
	@echo "setboard rnbqkb1r/p3pppp/1p6/2ppP3/3N4/2P5/PPP1QPPP/R1B1KB1R w KQkq" >>runprof
	@echo "move" >>runprof
	@echo "setboard r1b2rk1/2q1b1pp/p2ppn2/1p6/3QP3/1BN1B3/PPP3PP/R4RK1 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 2r3k1/pppR1pp1/4p3/4P1P1/5P2/1P4K1/P1P5/8 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 1nk1r1r1/pp2n1pp/4p3/q2pPp1N/b1pP1P2/B1P2R2/2P1B1PP/R2Q2K1 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 4b3/p3kp2/6p1/3pP2p/2pP1P2/4K1P1/P3N2P/8 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 2kr1bnr/pbpq4/2n1pp2/3p3p/3P1P1B/2N2N1Q/PPP3PP/2KR1B1R w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 3rr1k1/pp3pp1/1qn2np1/8/3p4/PP1R1P2/2P1NQPP/R1B3K1 b" >>runprof
	@echo "move" >>runprof
	@echo "setboard 2r1nrk1/p2q1ppp/bp1p4/n1pPp3/P1P1P3/2PBB1N1/4QPPP/R4RK1 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard r3r1k1/ppqb1ppp/8/4p1NQ/8/2P5/PP3PPP/R3R1K1 b" >>runprof
	@echo "move" >>runprof
	@echo "setboard r2q1rk1/4bppp/p2p4/2pP4/3pP3/3Q4/PP1B1PPP/R3R1K1 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard rnb2r1k/pp2p2p/2pp2p1/q2P1p2/8/1Pb2NP1/PB2PPBP/R2Q1RK1 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 2r3k1/1p2q1pp/2b1pr2/p1pp4/6Q1/1P1PP1R1/P1PN2PP/5RK1 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard r1bqkb1r/4npp1/p1p4p/1p1pP1B1/8/1B6/PPPN1PPP/R2Q1RK1 w kq" >>runprof
	@echo "move" >>runprof
	@echo "setboard r2q1rk1/1ppnbppp/p2p1nb1/3Pp3/2P1P1P1/2N2N1P/PPB1QP2/R1B2RK1 b" >>runprof
	@echo "move" >>runprof
	@echo "setboard r1bq1rk1/pp2ppbp/2np2p1/2n5/P3PP2/N1P2N2/1PB3PP/R1B1QRK1 b" >>runprof
	@echo "move" >>runprof
	@echo "setboard 3rr3/2pq2pk/p2p1pnp/8/2QBPP2/1P6/P5PP/4RRK1 b" >>runprof
	@echo "move" >>runprof
	@echo "setboard r4k2/pb2bp1r/1p1qp2p/3pNp2/3P1P2/2N3P1/PPP1Q2P/2KRR3 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 3rn2k/ppb2rpp/2ppqp2/5N2/2P1P3/1P5Q/PB3PPP/3RR1K1 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard 2r2rk1/1bqnbpp1/1p1ppn1p/pP6/N1P1P3/P2B1N1P/1B2QPP1/R2R2K1 b" >>runprof
	@echo "move" >>runprof
	@echo "setboard r1bqk2r/pp2bppp/2p5/3pP3/P2Q1P2/2N1B3/1PP3PP/R4RK1 b kq" >>runprof
	@echo "move" >>runprof
	@echo "setboard r2qnrnk/p2b2b1/1p1p2pp/2pPpp2/1PP1P3/PRNBB3/3QNPPP/5RK1 w" >>runprof
	@echo "move" >>runprof
	@echo "setboard /k/3p/p2P1p/P2P1P///K/ w" >>runprof
	@echo "move" >>runprof
	@echo "setboard /k/rnn////5RBB/K/ w" >>runprof
	@echo "move" >>runprof
	@echo "mt=0" >>runprof
	@echo "quit" >>runprof
	@echo "EOF" >>runprof
	@chmod +x runprof
	@./runprof
	@echo "#!/bin/csh" > runprof
	@echo "./crafty <<EOF" >>runprof
	@echo "st=10" >>runprof
	@echo "ponder=off" >>runprof
	@echo "mt=2" >>runprof
	@echo "setboard 2r2rk1/1bqnbpp1/1p1ppn1p/pP6/N1P1P3/P2B1N1P/1B2QPP1/R2R2K1 b" >>runprof
	@echo "move" >>runprof
	@echo "mt=0" >>runprof
	@echo "quit" >>runprof
	@echo "EOF" >>runprof
	@chmod +x runprof
	@./runprof
	@rm runprof
	@touch *.c *.cpp *.h
	$(MAKE) linux-64

#
#  one of the two following definitions for "objects" should be used.  The
#  default is to compile everything separately.  However, if you use the 
#  definition that refers to crafty.o, that will compile using the file crafty.c
#  which #includes every source file into one large glob.  This gives the
#  compiler max opportunity to inline functions as appropriate.  You should try
#  compiling both ways to see which way produces the fastest code.
#

#objects = search.o thread.o repeat.o next.o killer.o quiesce.o evaluate.o    \
       movgen.o make.o unmake.o hash.o  attacks.o swap.o boolean.o utility.o  \
       probe.o book.o data.o drawn.o edit.o epd.o epdglue.o init.o input.o    \
       interupt.o iterate.o main.o option.o output.o ponder.o resign.o root.o \
       learn.o setboard.o test.o time.o validate.o annotate.o analyze.o       \
       evtest.o bench.o
objects = crafty.o

# Do not change anything below this line!

opts = $(opt) -D$(target)

=== debian/changelog ===
crafty (23.4-9) unstable; urgency=medium

  * Adopt package inside Games Team (Closes: #835321)
  * Remove kfreebsd-amd64 support

 -- Alexandre Detiste <tchet@debian.org>  Wed, 02 Apr 2025 11:23:43 +0200

crafty (23.4-8) unstable; urgency=medium

  * QA upload.

  * Added d/gbp.conf to describe branch layout.
  * Updated vcs in d/control to Salsa.
  * Updated d/gbp.conf to enforce the use of pristine-tar.
  * Updated Standards-Version from 3.9.2 to 4.7.0.
  * Use wrap-and-sort -at for debian control files
  * Moved to debhelper compat level 13.

 -- Petter Reinholdtsen <pere@debian.org>  Sun, 28 Apr 2024 00:53:58 +0200

crafty (23.4-7) unstable; urgency=medium

  * QA upload.
  * Raise debhelper compat level to 9.
  * Drop README.source. Package is in "3.0 (quilt)" format.
  * Package is orphaned (Bug #835321), set Maintainer to "Debian QA Group".
  * Do not generate CPU specific code. Should fix "Illegal instruction" on
    some Pentium 4 CPUs. Closes: #850979.
  * Drop emacs local variables from the changelog.
  * Drop spurious spaces in several files.

 -- Santiago Vila <sanvila@debian.org>  Wed, 11 Jan 2017 20:02:00 +0100

crafty (23.4-6) unstable; urgency=low

  * Ubuntus oneiric build faild, because with linking the order of
    options matters. Oneiric uses ld-as-needed. Applied patch from
    Daniel T Chen <seven.steps@gmail.com>, thanks. (Closes: #641383)

 -- Oliver Korff <ok@xynyx.de>  Thu, 13 Oct 2011 22:22:40 +0200

crafty (23.4-5) unstable; urgency=low

  * Added a build dependency on kfreebsd-amd64 on libnuma-dev. Now FTBFS
    should be solved there.
  * Update to Standards-Version: 3.9.2 No changes.

 -- Oliver Korff <ok@xynyx.de>  Mon, 23 May 2011 15:58:07 +0200

crafty (23.4-4) unstable; urgency=low

  * The changes for 23.4-3 were highly supported by Mike Rohleder
    <mike@rohleder.de> this had to be clarified. Thanks!
  * Stripped README.Debian a bit and deleted deprecated entries
    of the previous maintainer, Eric Van Buggenhaut
    <ericvb@debian.org> (Closes: #621051)
  * The setgid r/w files in /var/lib/crafty have not been tolerable
    and are not necessary, if crafty is used in a $HOME/.crafty
    setup. This is ATM supported by executing the setup-crafty.sh
    from /usr/share/doc/crafty. Removed documetation of the old
    setup README.Debian. (Closes: #621052)

 -- Oliver Korff <ok@xynyx.de>  Wed, 06 Apr 2011 17:15:49 +0200

crafty (23.4-3) unstable; urgency=low

  * Small changes to annotata.c make the annotation with .png graphics
    possible. This will be useful with the crafty-bitmaps package. And
    later close the related bug, if the crafty-bitmaps package hit the
    contrib repository.
  * Displaying crafty.hlp by crafty could not bedone, dh_compress
    compresses it. So crafty.hlp is now excluded.

 -- Oliver Korff <ok@xynyx.de>  Mon, 04 Apr 2011 21:10:27 +0200

crafty (23.4-2) unstable; urgency=low

  * Update to the version from experimental. Upload to experimental was only done,
    not to mix up anything with the release and to test the build on architectures.

 -- Oliver Korff <ok@xynyx.de>  Mon, 28 Feb 2011 12:06:49 +0100

crafty (23.4-1) experimental; urgency=low

  * New Upstream Version
  * Repack of the source, to remove binary content.
  * Upload to experimental, to test the build of the different architectures.
  * Switch to Quilt and Source format 3.0. Moved all build intelligence to
    the new debian rules.
  * Because of architecture dependent building issues this upload is done to
    experimental. The correct built on amd64 was tested on pergolesi, the other
    systems have to be reconsidered, if the buildds show problems.

 -- Oliver Korff <ok@xynyx.de>  Wed, 12 Jan 2011 08:55:22 +0100

crafty (23.3-1) unstable; urgency=low

  * New Upstream Version
  * Because crafty as non-free software is now built by the buildds
    architecture dependent building issues were encountered. They result
    from the optimizing code inside of crafty. The solution is to include
    the optimizing only there, where it is working. So there are now more
    architecture dependent targets in the debian rules file.
    (Closes: #593111)
  * Update to Standards Version: 3.9.1

 -- Oliver Korff <ok@xynyx.de>  Thu, 19 Aug 2010 11:02:47 +0200

crafty (23.2-1) unstable; urgency=low

  * New Upstream Version
  * The 01-Makefile patch had to be recreated, because of too many
    changes by upstream. The linux-generic target has been added for
    building on other architectures. It has been tested in general
    at i386.
  * There was a -pg profiling switch in the linux target in
    the Makefile, this was corrected.
  * Corrected a small spelling error in the binary.

 -- Oliver Korff <ok@xynyx.de>  Sat, 06 Mar 2010 12:17:41 +0100

crafty (23.1-1) unstable; urgency=low

  * Started over with repackaging from fresh debhelper templates
  * Used a copy of: control, changelog, copyright, crafty.6, craftyrc.5,
    README.Debian and crafty.rc.
  * Removed menu. I don't want to depend on xboard, but this would be
    necessary, if I use a menu entry with xboard.
  * The 01_Makefile patch had to be adjusted.
  * New Upstream Release

 -- Oliver Korff <ok@xynyx.de>  Thu, 07 Jan 2010 00:18:16 +0100

crafty (22.10-4) unstable; urgency=low

  * To make autobuild possible on different architectures
    the Makefile was extended by a linux-generic target.
    (Closes: #549587) This was done by generating the 01-Makefile
    patch. The former 01-build patch is included now and removed.
  * The linux generic target was stripped of any optimizations
  * Set a build depends for libnuma-dev only where it is
    used by the makefile: libnuma-dev [amd64]

 -- Oliver Korff <ok@xynyx.de>  Mon, 05 Oct 2009 20:44:56 +0200

crafty (22.10-3) unstable; urgency=low

  * To repair amd64 build issues a patch of Christoph Berg
    <myon@debian.org> was added to the patchset
  * The 01-build.dpatch had to be corrected
  * Included the newest copyright notice of the upstream author


=== debian/control ===
Source: crafty
Section: non-free/games
Priority: optional
Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Alexandre Detiste <tchet@debian.org>,
Build-Depends:
 debhelper-compat (= 13),
 libnuma-dev [amd64],
Standards-Version: 4.7.2
XS-Autobuild: yes
Homepage: https://craftychess.com/
Vcs-Browser: https://salsa.debian.org/games-team/crafty
Vcs-Git: https://salsa.debian.org/games-team/crafty.git
Rules-Requires-Root: no
X-Style: black

Package: crafty
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 crafty-books-medtosmall | crafty-books-small,
 xboard,
Description: state-of-the-art chess engine, compatible with xboard
 Crafty is the strong chess program played on ICC. It uses all of the
 search algorithms you have probably read about and performs better
 than gnu-chess in most positions. It has a reasonable set of features to use,
 and offers a great starting point to try your own new search extensions.

=== debian/rules ===
#!/usr/bin/make -f

#export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

TARGET := darwin

ifneq (,$(findstring amd64,$(DEB_BUILD_ARCH)))
TARGET := linux-amd64
endif

%:
	dh $@

override_dh_auto_build:
	$(MAKE) $(TARGET)

override_dh_auto_clean:
	$(MAKE) clean
	rm -f *.o crafty game* log* position* books.bin book.bin book.lrn *.gcno lala
	rm -rf debian/tmp

override_dh_auto_test:
	@echo "Little Test"
	@echo "sd 15" > lala
	@echo "e4" >> lala
	@echo "end" >> lala
	@echo "input lala" | ./crafty

override_dh_installchangelogs:
	mkdir -p debian/x
	grep '^ \*' main.c > debian/x/changelog
	dh_installchangelogs debian/x/changelog
	rm debian/x/changelog

override_dh_compress:
	dh_compress -Xcrafty.hlp

=== debian/watch ===
version=4

ftp://ftp.cis.uab.edu/pub/hyatt/source/crafty-([\d.]+)\.zip
